/*
   This file is part of the Aulib library.
   Name: aucache.cpp
   Copyright (C) 2004 Silvia Pfeiffer

   Lehrstuhl fuer Praktische Informatik IV
   Universitaet Mannheim
   68131 Mannheim
   Germany
   email: pfeiffer@pi4.informatik.uni-mannheim.de

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/

#include "aucache.h"

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
//                    AudioCache

AudioCache& AudioCache::operator=(const AudioCache& c) {
  if (_samplingRate != c._samplingRate)
    throw Exception("AudioCache::operator=() - different sampling rates.");
  Array<Sample>::operator=(c);
  return *this;
}

////////////////////////////////////////////////////////////

ostream& AudioCache::printOn(ostream& os) const {
  os << "[AudioCache, sampling rate = " << _samplingRate
    << "Hz, channels = 1, bytes per sample = 2"
    << ", data format = lin16, size = " << _size
    << ", data: ";
  for (size_type i = 0; i < _size; i++)
    os << _data[i] << " ";
  os << "]";
  return os;
}

