/*
   This file is part of the Aulib library.
   Name: auformat.cpp
   Copyright (C) 2004 Silvia Pfeiffer

   Lehrstuhl fuer Praktische Informatik IV
   Universitaet Mannheim
   68131 Mannheim
   Germany
   email: pfeiffer@pi4.informatik.uni-mannheim.de

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/

#include "auformat.h"

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
//                    DataFormat

#ifdef AF
AEncodeType DataFormat::AFEncodeType(FormatCode type) {
  FormatCode htype = (type == lin8) ? mulaw : type;
  return AFFindEncodeType((char*)_names[htype - 1]);
}
#endif

////////////////////////////////////////////////////////////

const char* DataFormat::_names[] = {
  "mulaw", "LIN8", "LIN16", "LIN24", "LIN32",
  "IEEES", "IEEED", "FRAG", "" };

////////////////////////////////////////////////////////////

const uint32 DataFormat::_bytesInSample[] = {
  1, 1, 2, 3, 4, 4, 8, 0, 0 };

