/*
   This file is part of the Aulib library.
   Name: autypes.h
   Copyright (C) 2004 Silvia Pfeiffer

   Lehrstuhl fuer Praktische Informatik IV
   Universitaet Mannheim
   68131 Mannheim
   Germany
   email: pfeiffer@pi4.informatik.uni-mannheim.de

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/

#ifndef _AU_TYPES_H_
#define _AU_TYPES_H_

#ifdef OLDGNU
#include <iostream.h>
#else
#include <iostream>
#endif

/*
 * This file contains a set of global types, constants and enumerators
 * used by aulib++.
 */

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
//                         typedef

/// 8 Bit unsigned character
typedef unsigned char uchar8;

/// 8 Bit signed character
typedef char char8;

/// 16 Bit unsigned integer
typedef unsigned short uint16;

/// 16 Bit signed integer
typedef short int16;

/// 32 Bit unsigned integer
typedef unsigned int uint32;

/// 32 Bit signed integer
typedef int int32;

/// 64 Bit unsigned integer
typedef unsigned long  uint64;

/// 64 Bit signed integer
typedef long int64;

/// floating point
typedef float Float;

/// represents single Byte
typedef unsigned char Byte;

/// represents an audio sample
typedef int Sample;

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
//                         const

/// number of frames per second.
extern const double FPS_C;

/// maximal positive sample amplitude
extern const Sample MAX_AMP;

/// maximal negative sample amplitude
extern const Sample MIN_AMP;

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
//                       variables

/// output stream for log messages.
extern ostream& cres;

#endif
