/*
   This file is part of the Aulib library.
   Name: rangeTableFile.H
   Copyright (C) 2004 Silvia Pfeiffer

   Lehrstuhl fuer Praktische Informatik IV
   Universitaet Mannheim
   68131 Mannheim
   Germany
   email: pfeiffer@pi4.informatik.uni-mannheim.de

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/

#ifndef _RANGETABLEFILE_H
#define _RANGETABLEFILE_H


#include <iostream.h>
#include <fstream.h>
#ifndef _WIN32
#include <string>
#else
#include <bstring.h>
#endif
#include "rangeTableType.H"

class rangeTableFile {
public:
  string filename;

  int newDB(string _filename, int _startFrameNo, int _stopFrameNo);
  int openDB(string _filename, int _startFrameNo, int _stopFrameNo);
  int save(rangeTableType value);
  rangeTableType load(int _startFrameNo, int _stopFrameNo);
  
  rangeTableFile ();
  ~rangeTableFile ();
protected:
  // film data;
  string dir;
  int startFrameNo, stopFrameNo;
  
  // temp data
  char buffer[100];

};

#endif _RANGETABLEFILE_H
