/*
   This file is part of the Aulib library.
   Name: scalarFile.H
   Copyright (C) 2004 Silvia Pfeiffer

   Lehrstuhl fuer Praktische Informatik IV
   Universitaet Mannheim
   68131 Mannheim
   Germany
   email: pfeiffer@pi4.informatik.uni-mannheim.de

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/

#ifndef _SCALARFILE_H
#define _SCALARFILE_H

#include <stdio.h>
#ifndef _WIN32
#include <string>
#else
#include <bstring.h>
#endif
#include "scalarType.H"

class scalarFile {
public:
  string filename;
  float minValue, maxValue;

  int newDB(string _filename, int _startFrameNo, int _stopFrameNo);
  int openDB(string _filename, int _startFrameNo, int _stopFrameNo,
	     bool newIfFailed = true);
  int save(int frameNo, scalarType value);
  scalarType load(int frameNo);

  scalarFile ();
  ~scalarFile ();
protected:
  // file handle to the DB
  // always open as long as the DB is open
  // NULL = no DB open
  // NULL != DB already open
  FILE *file;
  // film data;
  string dir;
  int startFrameNo, stopFrameNo;

  // temp data
  char buffer[100];

};

#endif _SCALARFILE_H
