/*
   This file is part of the Aulib library.
   Name: scalarType.H
   Copyright (C) 2004 Silvia Pfeiffer

   Lehrstuhl fuer Praktische Informatik IV
   Universitaet Mannheim
   68131 Mannheim
   Germany
   email: pfeiffer@pi4.informatik.uni-mannheim.de

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/

#ifndef _SCLARATYPE_H
#define _SCLARATYPE_H

#include <stdio.h>
#include <iostream.h>
#include <limits.h>

#ifndef RETURNVECTOR
#define RETURNVECTOR(scl) sprintf(buffer,"%p", &scl);
#endif RETURNVECTOR
#ifndef RETURNVECTORPTR
#define RETURNVECTORPTR(scl) sprintf(buffer,"%p", scl);
#endif RETURNVECTORPTR

struct scalarType {
  friend ostream& operator<<(ostream&, const scalarType&);
  //  friend istream& operator>>(istream&, scalarType&);

  unsigned char calculated;
  float value;

  scalarType();
  scalarType(const scalarType& _scl);

  scalarType(float val);

  scalarType& operator= (const scalarType& _scl);

  float distance_L1 (const scalarType& s, float threshold = 0);
  float distance_L2 (const scalarType& s, float threshold = 0);

  void read(FILE *file);
  void write(FILE *file);

  // returns the size of one sclar in the DB
  size_t fileSize() {return (sizeof(float) + sizeof(unsigned char));}
};


inline scalarType&
GetScalar(char* string)
{
  scalarType* sclPtr;
  sscanf(string,"%p",&sclPtr);
  return *sclPtr;
}


ostream&
operator<<(ostream& os, const scalarType& s);

#endif _SCALARTYPE_H
