/*
   This file is part of the Aulib library.
   Name: zerocrossing.cpp
   Copyright (C) 2004 Silvia Pfeiffer

   Lehrstuhl fuer Praktische Informatik IV
   Universitaet Mannheim
   68131 Mannheim
   Germany
   email: pfeiffer@pi4.informatik.uni-mannheim.de

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/

#include "zerocrossing.h"
#include "aucache.h"

using namespace std;

double AuZerocrossing::zerocrossing(const AudioCache& cache) {
  int sum = 0;

  for (size_t i = 1; i < cache.size(); i++) {
    if (((cache[i-1] > 0) && (cache[i] < 0)) ||
	((cache[i-1] < 0) && (cache[i] > 0))) {
        sum += 1;
    }
  }

  return (double)sum/(double)cache.samplingRate();
}
